' ListZIP.VBS V1.04 (C) yoshioka.teruo@nifty.com 2007-11-21
' ListZIP.VBS lists ZIP file contents in command line.

Option Explicit
Const Usage="Usage: CScript.exe ListZIP.VBS ZIPfile..."
Dim ZIPfile

If WScript.Arguments.Count()<1 Then
  WScript.Echo Usage
  WScript.Quit
End If
For Each ZIPfile In WScript.Arguments
  ListZIP ZIPfile
Next
WScript.Quit

Sub ListZIP(ZIPfile)
Dim fso
Dim Shell
Dim Folder
Dim Rows
Dim k
Dim Columns(8)
Dim FolderItem

Set fso=CreateObject("Scripting.FileSystemObject")
If UCase(fso.GetExtensionName(ZIPfile))<>"ZIP" Then
  WScript.Echo "Invalid Extension Name -",ZIPfile
  WScript.Quit
End If
If Not fso.FileExists(ZIPfile) Then
  WScript.Echo "ZIP file not found. -",ZIPfile
  WScript.Quit
End If
Set Shell=CreateObject("Shell.Application")
Set Folder=Shell.NameSpace(fso.GetAbsolutePathName(ZIPfile))
Rows=Array(ZIPfile)
For k=0 To UBound(Columns)
  Columns(k)=Folder.GetDetailsOf(,k)
Next
Push Rows,Join(Columns,vbTab)
For Each FolderItem In Folder.Items()
  For k=0 To UBound(Columns)
    If k=5 Then
      Columns(k)=FolderItem.Size
    Else
      Columns(k)=Folder.GetDetailsOf(FolderItem,k)
    End If
  Next
  Push Rows,Join(Columns,vbTab)
Next
WScript.Echo Join(Rows,vbLf)
End Sub

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
